/** Events manager (singleton)
 *
 * @class EventManager
 *
 *
 * @author <a href="mailto:info@ilevia.com">info@ilevia.com</a>
 *
 * 
 * @required <a href="http://jquery.com/">jQuery</a>
 * 
 */
"use strict";

var EventManager = function() {
    
    /** Initialization function
     * 
     */
    var init = function() {
        console.log("%cEvents manager initialization","color:green");
        
        //Bind event
        m_$document.on("app/load/begin",function(e,msg,type){
            console.warn(e.type);
            
            //Open loader
            presenter.getWindow("loader").show(undefined,{
                type: type,
                message: msg
            });
        });
        
        //Bind event
        m_$document.on("app/load/end",function(e,msg,type){
            console.warn(e.type);
            
            //Open loader
            presenter.getWindow("loader").hide();
        });
        
        m_$document.on("app/info",function(e,msg){
            console.warn(e.type);
            
            presenter.getWindow("alert").show(undefined,{
                message: msg,
                type: "info"
            });
        });
        
        m_$document.on("app/warning",function(e,msg){
            //console.warn(e.type);
            
            presenter.getWindow("alert").show(undefined,{
                message: msg,
                type: "warning"
            });
        });
        
        m_$document.on("app/error",function(e,msg){
            //console.warn(e.type);
            
            presenter.getWindow("alert").show(undefined,{
                type: "error",
                message: msg
            });
            
            /*presenter.getWindow("alert").show(undefined,{
                message: msg,
                type: "error"
            });*/
        });

        m_$document.on("app/confirm",function(e,msg,cbFunc){
            console.warn(e.type);
            console.log(e);
            console.log(msg);
            console.log(cbFunc);

            presenter.getWindow("confirm").show(undefined,{
                message: msg,
                callback: cbFunc
            });
        });
    };
    
    /** Instance
     * 
     */
    var self = this;
    
    /** Instance
     * 
     */
    var m_$document = $(document);
    
    /** Loading counter (Start loading popup if counter > 0)
     * 
     */
    var loadingCounter = 0;
    
    //Methods
    this.onEvent = function(eventId,param){
        switch(eventId){
            case "app/load/begin":
                //
                self.loadingCounter++;
                if(self.loadingCounter == 1){
                    //Visualizzo popup modale
                    //Usare param.cbFunc()
                    //param();
                    param.cbFunc();
                }
                break;
            case "app/load/end":
                
                break;
            case "launchInfo":
                param.cbFunc();
                break;
        }
    };
    /** Dispatch event
     * 
     * @param eventId {String}
     * @param param{Array}
     */
    this.dispatchEvent = function(eventId,param){
        //Elaborazione parametri
        
        //Chiamare onEvent
        self.onEvent(eventId,param);
    };
    // "param" is an object [param.cbFunc is callback function]
    //this.dispatchLoadingBegin = function(cbFunc){
    this.dispatchLoadingBegin = function(param){
        self.onEvent("beginLoading",param);
    };
    
    //this.dispatchLoadingEnd = function(cbFunc){
    this.dispatchLoadingEnd = function(param){
        //Use param.cbFunc
        //self.onEvent("endLoading",cbFunc);
        self.onEvent("endLoading",param);
    };
    
    //Launch info
    this.dispatchInfoBox = function(param){
        self.onEvent("launchInfo",param);
    };
    
    init();
};