/** Alert class (extends Window class)
 *
 * @class Alert
 *
 *
 * @author <a href="mailto:info@ilevia.com">info@ilevia.com</a>
 *
 * 
 * @required <a href="http://jquery.com/">jQuery</a>
 * @required <a href="http://jqueryui.com/">jQuery UI</a>
 * 
 */
"use strict";

function Alert(oWindow){
	
	var self = this;
	
	/**
	 *
	 */
	var init = function(){
        console.log("%cWindow - Alert class initialization (extends Window class)","color:green");
        
        //Create jQuery UI dialog
        m_$element.dialog({
            closeOnEscape: true,
            minWidth: 250,
            modal: false,
            resizable: false,
            autoOpen: false,
            close: self.onHide
        });
        
        m_$element.find("button").button();
        
        m_$element.on("click","button",function(e){
            m_$element.dialog("close");
        });
        
        m_$element.find(".message").css("display","block");
        m_$element.find(".ui-icon").hide();
        m_$element.find(".message").removeClass("ui-state-error");
    };
	
	/** Extended window object 
     * @type {Window}
     */
	var m_oWindow = oWindow;
	
	/** jQuery DOM element representing Window GUI
     * @type {jQuery}
     */
    var m_$element;
    
	/** Show icon editor window
	 */
	this.show = function(oParam){
	    
	    switch(oParam.type){
	        case "info":
	           
	           break;
	        case "warning":
	           m_$element.find(".ui-icon").show();
	           m_$element.find(".message").css("display","inline");
               break;
            case "error":
                m_$element.find(".message").addClass("ui-state-error").css("display","block");
               break;
	    }
	    
	    m_$element.find(".message").html(oParam.message);
        
        m_$element.dialog("option","title",_D(oParam.type.capitalizeFirst()) );
	    
	    m_$element.dialog("open");
	};
	
	/** Hide icon editor window and closing operation
     */
    this.hide = function(e,ui){
        
    };
	
	/** Hide icon editor window and closing operation
	 */
	this.onHide = function(e,ui){
	    //m_$element.find(".message").css("display","block");
        m_$element.find(".message").css("display","block").empty().removeClass("ui-state-error");
	    m_$element.find(".ui-icon").hide();
	};
	
	/** Assign window HTML element 
     * @param $element jQuery element represent this window
     * @returns {Node}
     */
    this.assignWindow = function($element){
        m_$element = $element;
        
        //Initialization after graphic ready
        init();
    };
    
}