/**
 * Created by blr on 22/04/15.
 */
"use strict";

var VERSION = "v.1.0.0";
var NAME = "Eurotherm Smart Comfort Wizard " + VERSION;
var $ = jQuery;

try {
    console.log("%cStart " + NAME, "color:DarkSlateBlue");
    create_gui();
    console.log("%cEnd " + NAME, "color:DarkSlateBlue");
} catch (err) {
    console.error(NAME + " error\n" + err);
    alert(NAME + " error\n" + err);
}

function create_gui(){
    var wizard = $("<div id='eurothermsmartcomfot-wizard' title='" + NAME + "'></div>");
    wizard.append("</br><label>Name</label></br>");
    wizard.append("<input type='text' id='gtw-name' value='Eurotherm Smart Comfort'/></br>");
    wizard.append("</br><label>Address</label></br>");
    wizard.append("<input type='text' id='gtw-address' value='192.168.1.250'/></br>");
    wizard.append("</br><label>Port</label></br>");
    wizard.append("<input type='text' id='gtw-port' value='502' onkeypress='bigh.onlyPosInt();' /></br>");
    wizard.append("</br><label>Slave ID</label></br>");
    wizard.append("<input type='text' id='slave-id' value='1' onkeypress='bigh.onlyPosInt();' /></br>");
    wizard.append("</br><label>Numbers of zones</label></br>");
    wizard.append("<input type='text' id='zones-count' value='1' onkeypress='bigh.onlyPosInt();' /></br>");
    $("body").append(wizard);

    wizard.dialog({
        modal:true,
        width:350,
        close: function() {
            $( this ).remove();
        },
        buttons: {
            "Create Componens...": function() {
                $( this ).dialog( "close" );
                $( this ).remove();

                blr.executionStack.show(NAME);
                main(
                    $(this).children("#gtw-name").val(),
                    $(this).children("#gtw-address").val(),
                    $(this).children("#gtw-port").val(),
                    $(this).children("#slave-id").val(),
                    $(this).children("#zones-count").val()
                );
            },
            Cancel: function() {
                $( this ).dialog( "close" );
                $( this ).remove();
            }
        }
    });

    return wizard;
}

function main(name, ip, port, slaveID, zonesCount){
    try {
        var offsetRegister = 3551;
        var oGateway = getGateway(name, ip, port);
        var oGroup = getMainGroup(name);

        for(var i=0; i<zonesCount; ++i){
            var zoneID = i + 1;
            blr.executionStack.push(
            function (in_args, out_args) {
                out_args = createSmartBase(in_args.gateway,in_args.group, in_args.slaveID, in_args.zoneID, in_args.offset);
                },
                {
                    gateway: oGateway,
                    group: oGroup,
                    slaveID: slaveID,
                    zoneID: zoneID,
                    offset: offsetRegister*i
                }
            );

            for(var s=0; s<8; ++s) {
                var sensorID = s+1;
                blr.executionStack.push(
                    function (in_args, out_args) {
                        out_args = createSensor(in_args.gateway,in_args.group, in_args.slaveID, in_args.zoneID, in_args.sensorID, in_args.offset);
                    },
                    {
                        gateway: oGateway,
                        group: oGroup,
                        slaveID: slaveID,
                        zoneID: zoneID,
                        sensorID: sensorID,
                        offset: offsetRegister * i
                    }
                );

            }
        }

        blr.executionStack.execute(100,true);
    } catch (err) {
        console.error(NAME + " error\n" + err);
        alert(NAME + " error\n" + err);
    }
}

function createSmartBase(gateway,group,slaveID,zoneID,registerOffset) {
    var oItem = null;
    var oGroup = application.addComponent({
        type: "group",
        name: _D("Zone") + " " + zoneID
    }, group);

    // Ore
    oItem = application.addComponent({
        type: "info",
        gateway: gateway, 
        name: "Z" + zoneID + " " + _D("Hours"),
        "modbusrtutcp/read-unit-id": slaveID,
        "modbusrtutcp/read-function-id": 3, // (3) Read Holding Registers
        "modbusrtutcp/read-register-start": registerOffset + 60,
        "modbusrtutcp/read-register-count": 8,
        "modbusrtutcp/read-bit-start": 0,
        "modbusrtutcp/read-bit-count": 16,
        "modbusrtutcp/read-transform-type": 4, // Word
        "modbusrtutcp/read-transform-multiplier": 1
    }, oGroup);
    // Minuti
    oItem = application.addComponent({
        type: "info",
        gateway: gateway,
        name: "Z" + zoneID + " " + _D("Minutes"),
        "modbusrtutcp/read-unit-id": slaveID,
        "modbusrtutcp/read-function-id": 3, // (3) Read Holding Registers
        "modbusrtutcp/read-register-start": registerOffset + 60,
        "modbusrtutcp/read-register-count": 8,
        "modbusrtutcp/read-bit-start": 16,
        "modbusrtutcp/read-bit-count": 16,
        "modbusrtutcp/read-transform-type": 4, // Word
        "modbusrtutcp/read-transform-multiplier": 1
    }, oGroup);
    // Giorno
    oItem = application.addComponent({
        type: "info",
        gateway: gateway,
        name: "Z" + zoneID + " " + _D("Day"),
        "modbusrtutcp/read-unit-id": slaveID,
        "modbusrtutcp/read-function-id": 3, // (3) Read Holding Registers
        "modbusrtutcp/read-register-start": registerOffset + 60,
        "modbusrtutcp/read-register-count": 8,
        "modbusrtutcp/read-bit-start": 32,
        "modbusrtutcp/read-bit-count": 16,
        "modbusrtutcp/read-transform-type": 4, // Word
        "modbusrtutcp/read-transform-multiplier": 1
    }, oGroup);
    // Mese
    oItem = application.addComponent({
        type: "info",
        gateway: gateway,
        name: "Z" + zoneID + " " + _D("Month"),
        "modbusrtutcp/read-unit-id": slaveID,
        "modbusrtutcp/read-function-id": 3, // (3) Read Holding Registers
        "modbusrtutcp/read-register-start": registerOffset + 60,
        "modbusrtutcp/read-register-count": 8,
        "modbusrtutcp/read-bit-start": 48,
        "modbusrtutcp/read-bit-count": 16,
        "modbusrtutcp/read-transform-type": 4, // Word
        "modbusrtutcp/read-transform-multiplier": 1
    }, oGroup);
    // Anno
    oItem = application.addComponent({
        type: "info",
        gateway: gateway,
        name: "Z" + zoneID + " " + _D("Year"),
        "modbusrtutcp/read-unit-id": slaveID,
        "modbusrtutcp/read-function-id": 3, // (3) Read Holding Registers
        "modbusrtutcp/read-register-start": registerOffset + 60,
        "modbusrtutcp/read-register-count": 8,
        "modbusrtutcp/read-bit-start": 64,
        "modbusrtutcp/read-bit-count": 16,
        "modbusrtutcp/read-transform-type": 4, // Word
        "modbusrtutcp/read-transform-multiplier": 1
    }, oGroup);
    // Temperatura Esterna
    oItem = application.addComponent({
        type: "info",
        gateway: gateway,
        name: "Z" + zoneID + " " + _D("Temperature Outside"),
        "modbusrtutcp/read-unit-id": slaveID,
        "modbusrtutcp/read-function-id": 3, // (3) Read Holding Registers
        "modbusrtutcp/read-register-start": registerOffset + 60,
        "modbusrtutcp/read-register-count": 8,
        "modbusrtutcp/read-bit-start": 80,
        "modbusrtutcp/read-bit-count": 16,
        "modbusrtutcp/read-transform-type": 4, // Word
        "modbusrtutcp/read-transform-multiplier": 0.1
    }, oGroup);

    // Modalit� Vacanza
    oItem = application.addComponent({
        type: "combo",
        gateway: gateway,
        name: "Z" + zoneID + " " + _D("Holiday"),
        "modbusrtutcp/read-unit-id": slaveID,
        "modbusrtutcp/read-function-id": 3, // (3) Read Holding Registers
        "modbusrtutcp/read-register-start": registerOffset + 60,
        "modbusrtutcp/read-register-count": 8,
        "modbusrtutcp/read-bit-start": 96,
        "modbusrtutcp/read-bit-count": 16,
        "modbusrtutcp/read-transform-type": 1, // bit
        "modbusrtutcp/read-transform-min": 0,
        "modbusrtutcp/read-transform-max": 1,
        "modbusrtutcp/read-transform-multiplier": 1,
        "modbusrtutcp/write-unit-id": slaveID,
        "modbusrtutcp/write-function-id": 6, // (6) Write Single Register
        "modbusrtutcp/write-register-start": registerOffset + 66,
        "modbusrtutcp/write-register-count": 1,
        "modbusrtutcp/write-bit-start": -1,
        "modbusrtutcp/write-bit-count": 0,
        "modbusrtutcp/write-transform-type": 1, // bit
        "modbusrtutcp/write-transform-min": 0,
        "modbusrtutcp/write-transform-max": 1,
        "modbusrtutcp/write-transform-multiplier": 1,
        "values": [{
            "value": 0,
            "description": _D("Off")
        }, {
            "value": 1,
            "description": _D("Holiday")
        }],
        "icons": [
            blr.gfxResource.getIconByTypeName(0, "home"),
            blr.gfxResource.getIconByTypeName(1, "holiday")
        ]
    }, oGroup);

    // Stagione
    oItem = application.addComponent({
        type: "combo",
        gateway: gateway,
        name: "Z" + zoneID + " " + _D("Season"),
        "modbusrtutcp/read-unit-id": slaveID,
        "modbusrtutcp/read-function-id": 3, // (3) Read Holding Registers
        "modbusrtutcp/read-register-start": registerOffset + 60,
        "modbusrtutcp/read-register-count": 8,
        "modbusrtutcp/read-bit-start": 112,
        "modbusrtutcp/read-bit-count": 16,
        "modbusrtutcp/read-transform-type": 1, // bit
        "modbusrtutcp/read-transform-min": 0,
        "modbusrtutcp/read-transform-max": 1,
        "modbusrtutcp/read-transform-multiplier": 1,
        "modbusrtutcp/write-unit-id": slaveID,
        "modbusrtutcp/write-function-id": 6, // (6) Write Single Register
        "modbusrtutcp/write-register-start": registerOffset + 67,
        "modbusrtutcp/write-register-count": 1,
        "modbusrtutcp/write-bit-start": -1,
        "modbusrtutcp/write-bit-count": 0,
        "modbusrtutcp/write-transform-type": 1, // bit
        "modbusrtutcp/write-transform-min": 0,
        "modbusrtutcp/write-transform-max": 1,
        "modbusrtutcp/write-transform-multiplier": 1,
        "values": [{
            "value": 0,
            "description": _D(" ")
        }, {
            "value": 1,
            "description": _D("Winter")
        }],
        "icons": [
            blr.gfxResource.getIconByTypeName(0, "summer"),
            blr.gfxResource.getIconByTypeName(1, "winter")
        ]
    }, oGroup);

    // Tipo Dispositivo
    oItem = application.addComponent({
        type: "info-text",
        gateway: gateway,
        name: "Z" + zoneID + " " + _D("Device Type"),
        "text-0": "With Mix",
        "text-1": "Without Mix",
        "color-0": "#FFFFFF",
        "color-1": "#FFFFFF",
        "modbusrtutcp/read-unit-id": slaveID,
        "modbusrtutcp/read-function-id": 3, // (3) Read Holding Registers
        "modbusrtutcp/read-register-start": registerOffset + 100,
        "modbusrtutcp/read-register-count": 3,
        "modbusrtutcp/read-bit-start": 0,
        "modbusrtutcp/read-bit-count": 16,
        "modbusrtutcp/read-transform-type": 1,// Bit
        "modbusrtutcp/read-transform-min": 0,
        "modbusrtutcp/read-transform-max": 1,
        "modbusrtutcp/read-transform-multiplier": 1,
        "icons": [
            blr.gfxResource.getIconByTypeName(0, "mix"),
            blr.gfxResource.getIconByTypeName(1, "aux")
        ]
    }, oGroup);

    // Temperatura di mandata set point
    oItem = application.addComponent({
        type: "info",
        gateway: gateway,
        name: "Z" + zoneID + " " + _D("Delivery Temperature Setpoint"),
        "modbusrtutcp/read-unit-id": slaveID,
        "modbusrtutcp/read-function-id": 3, // (3) Read Holding Registers
        "modbusrtutcp/read-register-start": registerOffset + 100,
        "modbusrtutcp/read-register-count": 3,
        "modbusrtutcp/read-bit-start": 16,
        "modbusrtutcp/read-bit-count": 16,
        "modbusrtutcp/read-transform-type": 4, // Word
        "modbusrtutcp/read-transform-multiplier": 0.1
    }, oGroup);

    // Temperatura di mandata
    oItem = application.addComponent({
        type: "info",
        gateway: gateway,
        name: "Z" + zoneID + " " + _D("Delivery Temperature"),
        "modbusrtutcp/read-unit-id": slaveID,
        "modbusrtutcp/read-function-id": 3, // (3) Read Holding Registers
        "modbusrtutcp/read-register-start": registerOffset + 100,
        "modbusrtutcp/read-register-count": 3,
        "modbusrtutcp/read-bit-start": 32,
        "modbusrtutcp/read-bit-count": 16,
        "modbusrtutcp/read-transform-type": 4, // Word
        "modbusrtutcp/read-transform-multiplier": 0.1
    }, oGroup);

    return oGroup;
}


function createSensor(gateway,group, slaveID, zoneID, sensorID, registerOffset) {
    var oItem = null;
    var oGroup = application.addComponent({
        type: "group",
        name: _D("Zone ") + zoneID + " " + _D("Sensor") + " " + sensorID
    }, group);

    var sensorOffset = registerOffset + ((sensorID - 1) * 330);

    if (sensorID >= 7) {
        sensorOffset += 900; 
    }

    // Error
    oItem = application.addComponent({
        type: "info-text",
        gateway: gateway,
        name: "Z" + zoneID + " S" + sensorID + " " + _D("Error"),
        "text-0": "",
        "text-1": "Error",
        "color-0": "#00C800",
        "color-1": "#C80000",
        "modbusrtutcp/read-unit-id": slaveID,
        "modbusrtutcp/read-function-id": 3, // (3) Read Holding Registers
        "modbusrtutcp/read-register-start": sensorOffset + 120,
        "modbusrtutcp/read-register-count": 5,
        "modbusrtutcp/read-bit-start": 0,
        "modbusrtutcp/read-bit-count": 16,
        "modbusrtutcp/read-transform-type": 1,// bit
        "modbusrtutcp/read-transform-min": 0,
        "modbusrtutcp/read-transform-max": 1,
        "modbusrtutcp/read-transform-multiplier": 1,
        "icons": [
            blr.gfxResource.getIconByTypeName(0, "circle"),
            blr.gfxResource.getIconByTypeName(1, "triangle")
        ]
    }, oGroup);

    // Tipo
    oItem = application.addComponent({
        type: "info-text",
        gateway: gateway,
        name: "Z" + zoneID + " S" + sensorID + " " + _D("Type"),
        "text-0": "Temperature",
        "text-1": "Temperature and Umidity",
        "color-0": "#FFFFFF",
        "color-1": "#FFFFFF",
        "modbusrtutcp/read-unit-id": slaveID,
        "modbusrtutcp/read-function-id": 3, // (3) Read Holding Registers
        "modbusrtutcp/read-register-start": sensorOffset + 120,
        "modbusrtutcp/read-register-count": 5,
        "modbusrtutcp/read-bit-start": 16,
        "modbusrtutcp/read-bit-count": 16,
        "modbusrtutcp/read-transform-type": 2,// Byte
        "modbusrtutcp/read-transform-min": 1,
        "modbusrtutcp/read-transform-max": 2,
        "modbusrtutcp/read-transform-multiplier": 1,
        "icons": [
            blr.gfxResource.getIconByTypeName(1, "temperature"),
            blr.gfxResource.getIconByTypeName(2, "sun_cloud")
        ]
    }, oGroup);

    // Temperatura
    oItem = application.addComponent({
        type: "info",
        gateway: gateway,
        name: "Z" + zoneID + " S" + sensorID + " " + _D("Temperature"),
        "modbusrtutcp/read-unit-id": slaveID,
        "modbusrtutcp/read-function-id": 3, // (3) Read Holding Registers
        "modbusrtutcp/read-register-start": sensorOffset + 120,
        "modbusrtutcp/read-register-count": 5,
        "modbusrtutcp/read-bit-start": 48,
        "modbusrtutcp/read-bit-count": 16,
        "modbusrtutcp/read-transform-type": 4, // Word
        "modbusrtutcp/read-transform-multiplier": 0.1
    }, oGroup);

    // Umidit�
    oItem = application.addComponent({
        type: "info",
        gateway: gateway,
        name: "Z" + zoneID + " S" + sensorID + " " + _D("Umidity"),
        "modbusrtutcp/read-unit-id": slaveID,
        "modbusrtutcp/read-function-id": 3, // (3) Read Holding Registers
        "modbusrtutcp/read-register-start": sensorOffset + 120,
        "modbusrtutcp/read-register-count": 5,
        "modbusrtutcp/read-bit-start": 64,
        "modbusrtutcp/read-bit-count": 16,
        "modbusrtutcp/read-transform-type": 4, // Word
        "modbusrtutcp/read-transform-multiplier": 1
    }, oGroup);

    // Winter
    oItem = application.addComponent({
        type: "thermostat",
        gateway: gateway,
        name: "Z" + zoneID + " S" + sensorID + " " + _D("Winter") + " " + _D("Comfort"),
        step: 0.5,
        min: 5,
        max: 30,
        "modbusrtutcp/read-unit-id": slaveID,
        "modbusrtutcp/read-function-id": 3, // (3) Read Holding Registers
        "modbusrtutcp/read-register-start": sensorOffset + 140,
        "modbusrtutcp/read-register-count": 7,
        "modbusrtutcp/read-bit-start": 0,
        "modbusrtutcp/read-bit-count": 16,
        "modbusrtutcp/read-transform-type": 4, // word
        "modbusrtutcp/read-transform-min": 50,
        "modbusrtutcp/read-transform-max": 300,
        "modbusrtutcp/read-transform-multiplier": 0.1,
        "modbusrtutcp/write-unit-id": slaveID,
        "modbusrtutcp/write-function-id": 6, // (6) Write Single Register
        "modbusrtutcp/write-register-start": sensorOffset + 140,
        "modbusrtutcp/write-register-count": 1,
        "modbusrtutcp/write-bit-start": -1,
        "modbusrtutcp/write-bit-count": 0,
        "modbusrtutcp/write-transform-type": 4, // word
        "modbusrtutcp/write-transform-min": 50,
        "modbusrtutcp/write-transform-max": 300,
        "modbusrtutcp/write-transform-multiplier": 0.1,
        "icons": [
            blr.gfxResource.getIconByTypeName(0, "comfort"),
            blr.gfxResource.getIconByTypeName(1, "less"),
            blr.gfxResource.getIconByTypeName(2, "circle"),
            blr.gfxResource.getIconByTypeName(3, "plus")
        ]
    }, oGroup);
    oItem = application.addComponent({
        type: "timed-thermostat",
        gateway: gateway,
        name: "Z" + zoneID + " S" + sensorID + " " + _D("Winter") + " " + _D("Comfort") + " " + _D("Timed"),
        step: 0.5,
        min: 5,
        max: 30,
        "modbusrtutcp/read-unit-id": slaveID,
        "modbusrtutcp/read-function-id": 3, // (3) Read Holding Registers
        "modbusrtutcp/read-register-start": sensorOffset + 140,
        "modbusrtutcp/read-register-count": 7,
        "modbusrtutcp/read-bit-start": 0,
        "modbusrtutcp/read-bit-count": 16,
        "modbusrtutcp/read-transform-type": 4, // word
        "modbusrtutcp/read-transform-min": 50,
        "modbusrtutcp/read-transform-max": 300,
        "modbusrtutcp/read-transform-multiplier": 0.1,
        "modbusrtutcp/write-unit-id": slaveID,
        "modbusrtutcp/write-function-id": 6, // (6) Write Single Register
        "modbusrtutcp/write-register-start": sensorOffset + 140,
        "modbusrtutcp/write-register-count": 1,
        "modbusrtutcp/write-bit-start": -1,
        "modbusrtutcp/write-bit-count": 0,
        "modbusrtutcp/write-transform-type": 4, // word
        "modbusrtutcp/write-transform-min": 50,
        "modbusrtutcp/write-transform-max": 300,
        "modbusrtutcp/write-transform-multiplier": 0.1
    }, oGroup);

    oItem = application.addComponent({
        type: "thermostat",
        gateway: gateway,
        name: "Z" + zoneID + " S" + sensorID + " " + _D("Winter") + " " + _D("Standby"),
        step: 0.5,
        min: 5,
        max: 30,
        "modbusrtutcp/read-unit-id": slaveID,
        "modbusrtutcp/read-function-id": 3, // (3) Read Holding Registers
        "modbusrtutcp/read-register-start": sensorOffset + 140,
        "modbusrtutcp/read-register-count": 7,
        "modbusrtutcp/read-bit-start": 16,
        "modbusrtutcp/read-bit-count": 16,
        "modbusrtutcp/read-transform-type": 4, // word
        "modbusrtutcp/read-transform-min": 50,
        "modbusrtutcp/read-transform-max": 300,
        "modbusrtutcp/read-transform-multiplier": 0.1,
        "modbusrtutcp/write-unit-id": slaveID,
        "modbusrtutcp/write-function-id": 6, // (6) Write Single Register
        "modbusrtutcp/write-register-start": sensorOffset + 141,
        "modbusrtutcp/write-register-count": 1,
        "modbusrtutcp/write-bit-start": -1,
        "modbusrtutcp/write-bit-count": 0,
        "modbusrtutcp/write-transform-type": 4, // word
        "modbusrtutcp/write-transform-min": 50,
        "modbusrtutcp/write-transform-max": 300,
        "modbusrtutcp/write-transform-multiplier": 0.1,
        "icons": [
            blr.gfxResource.getIconByTypeName(0, "standby"),
            blr.gfxResource.getIconByTypeName(1, "less"),
            blr.gfxResource.getIconByTypeName(2, "circle"),
            blr.gfxResource.getIconByTypeName(3, "plus")
        ]
    }, oGroup);
    oItem = application.addComponent({
        type: "timed-thermostat",
        gateway: gateway,
        name: "Z" + zoneID + " S" + sensorID + " " + _D("Winter") + " " + _D("Standby") + " " + _D("Timed"),
        step: 0.5,
        min: 5,
        max: 30,
        "modbusrtutcp/read-unit-id": slaveID,
        "modbusrtutcp/read-function-id": 3, // (3) Read Holding Registers
        "modbusrtutcp/read-register-start": sensorOffset + 140,
        "modbusrtutcp/read-register-count": 7,
        "modbusrtutcp/read-bit-start": 16,
        "modbusrtutcp/read-bit-count": 16,
        "modbusrtutcp/read-transform-type": 4, // word
        "modbusrtutcp/read-transform-min": 50,
        "modbusrtutcp/read-transform-max": 300,
        "modbusrtutcp/read-transform-multiplier": 0.1,
        "modbusrtutcp/write-unit-id": slaveID,
        "modbusrtutcp/write-function-id": 6, // (6) Write Single Register
        "modbusrtutcp/write-register-start": sensorOffset + 141,
        "modbusrtutcp/write-register-count": 1,
        "modbusrtutcp/write-bit-start": -1,
        "modbusrtutcp/write-bit-count": 0,
        "modbusrtutcp/write-transform-type": 4, // word
        "modbusrtutcp/write-transform-min": 50,
        "modbusrtutcp/write-transform-max": 300,
        "modbusrtutcp/write-transform-multiplier": 0.1
    }, oGroup);

    oItem = application.addComponent({
        type: "thermostat",
        gateway: gateway,
        name: "Z" + zoneID + " S" + sensorID + " " + _D("Winter") + " " + _D("Night"),
        step: 0.5,
        min: 5,
        max: 30,
        "modbusrtutcp/read-unit-id": slaveID,
        "modbusrtutcp/read-function-id": 3, // (3) Read Holding Registers
        "modbusrtutcp/read-register-start": sensorOffset + 140,
        "modbusrtutcp/read-register-count": 7,
        "modbusrtutcp/read-bit-start": 32,
        "modbusrtutcp/read-bit-count": 16,
        "modbusrtutcp/read-transform-type": 4, // word
        "modbusrtutcp/read-transform-min": 50,
        "modbusrtutcp/read-transform-max": 300,
        "modbusrtutcp/read-transform-multiplier": 0.1,
        "modbusrtutcp/write-unit-id": slaveID,
        "modbusrtutcp/write-function-id": 6, // (6) Write Single Register
        "modbusrtutcp/write-register-start": sensorOffset + 142,
        "modbusrtutcp/write-register-count": 1,
        "modbusrtutcp/write-bit-start": -1,
        "modbusrtutcp/write-bit-count": 0,
        "modbusrtutcp/write-transform-type": 4, // word
        "modbusrtutcp/write-transform-min": 50,
        "modbusrtutcp/write-transform-max": 300,
        "modbusrtutcp/write-transform-multiplier": 0.1,
        "icons": [
            blr.gfxResource.getIconByTypeName(0, "night"),
            blr.gfxResource.getIconByTypeName(1, "less"),
            blr.gfxResource.getIconByTypeName(2, "circle"),
            blr.gfxResource.getIconByTypeName(3, "plus")
        ]
    }, oGroup);
    oItem = application.addComponent({
        type: "timed-thermostat",
        gateway: gateway,
        name: "Z" + zoneID + " S" + sensorID + " " + _D("Winter") + " " + _D("Night") + " " + _D("Timed"),
        step: 0.5,
        min: 5,
        max: 30,
        "modbusrtutcp/read-unit-id": slaveID,
        "modbusrtutcp/read-function-id": 3, // (3) Read Holding Registers
        "modbusrtutcp/read-register-start": sensorOffset + 140,
        "modbusrtutcp/read-register-count": 7,
        "modbusrtutcp/read-bit-start": 32,
        "modbusrtutcp/read-bit-count": 16,
        "modbusrtutcp/read-transform-type": 4, // word
        "modbusrtutcp/read-transform-min": 50,
        "modbusrtutcp/read-transform-max": 300,
        "modbusrtutcp/read-transform-multiplier": 0.1,
        "modbusrtutcp/write-unit-id": slaveID,
        "modbusrtutcp/write-function-id": 6, // (6) Write Single Register
        "modbusrtutcp/write-register-start": sensorOffset + 142,
        "modbusrtutcp/write-register-count": 1,
        "modbusrtutcp/write-bit-start": -1,
        "modbusrtutcp/write-bit-count": 0,
        "modbusrtutcp/write-transform-type": 4, // word
        "modbusrtutcp/write-transform-min": 50,
        "modbusrtutcp/write-transform-max": 300,
        "modbusrtutcp/write-transform-multiplier": 0.1
    }, oGroup);

    // Summer
    oItem = application.addComponent({
        type: "thermostat",
        gateway: gateway,
        name: "Z" + zoneID + " S" + sensorID + " " + _D("Summer") + " " + _D("Comfort"),
        step: 0.5,
        min: 5,
        max: 30,
        "modbusrtutcp/read-unit-id": slaveID,
        "modbusrtutcp/read-function-id": 3, // (3) Read Holding Registers
        "modbusrtutcp/read-register-start": sensorOffset + 140,
        "modbusrtutcp/read-register-count": 7,
        "modbusrtutcp/read-bit-start": 48,
        "modbusrtutcp/read-bit-count": 16,
        "modbusrtutcp/read-transform-type": 4, // word
        "modbusrtutcp/read-transform-min": 50,
        "modbusrtutcp/read-transform-max": 300,
        "modbusrtutcp/read-transform-multiplier": 0.1,
        "modbusrtutcp/write-unit-id": slaveID,
        "modbusrtutcp/write-function-id": 6, // (6) Write Single Register
        "modbusrtutcp/write-register-start": sensorOffset + 143,
        "modbusrtutcp/write-register-count": 1,
        "modbusrtutcp/write-bit-start": -1,
        "modbusrtutcp/write-bit-count": 0,
        "modbusrtutcp/write-transform-type": 4, // word
        "modbusrtutcp/write-transform-min": 50,
        "modbusrtutcp/write-transform-max": 300,
        "modbusrtutcp/write-transform-multiplier": 0.1,
        "icons": [
            blr.gfxResource.getIconByTypeName(0, "comfort"),
            blr.gfxResource.getIconByTypeName(1, "less"),
            blr.gfxResource.getIconByTypeName(2, "circle"),
            blr.gfxResource.getIconByTypeName(3, "plus")
        ]
    }, oGroup);
    oItem = application.addComponent({
        type: "timed-thermostat",
        gateway: gateway,
        name: "Z" + zoneID + " S" + sensorID + " " + _D("Summer") + " " + _D("Comfort") + " " + _D("Timed"),
        step: 0.5,
        min: 5,
        max: 30,
        "modbusrtutcp/read-unit-id": slaveID,
        "modbusrtutcp/read-function-id": 3, // (3) Read Holding Registers
        "modbusrtutcp/read-register-start": sensorOffset + 140,
        "modbusrtutcp/read-register-count": 7,
        "modbusrtutcp/read-bit-start": 48,
        "modbusrtutcp/read-bit-count": 16,
        "modbusrtutcp/read-transform-type": 4, // word
        "modbusrtutcp/read-transform-min": 50,
        "modbusrtutcp/read-transform-max": 300,
        "modbusrtutcp/read-transform-multiplier": 0.1,
        "modbusrtutcp/write-unit-id": slaveID,
        "modbusrtutcp/write-function-id": 6, // (6) Write Single Register
        "modbusrtutcp/write-register-start": sensorOffset + 143,
        "modbusrtutcp/write-register-count": 1,
        "modbusrtutcp/write-bit-start": -1,
        "modbusrtutcp/write-bit-count": 0,
        "modbusrtutcp/write-transform-type": 4, // word
        "modbusrtutcp/write-transform-min": 50,
        "modbusrtutcp/write-transform-max": 300,
        "modbusrtutcp/write-transform-multiplier": 0.1
    }, oGroup);

    oItem = application.addComponent({
        type: "thermostat",
        gateway: gateway,
        name: "Z" + zoneID + " S" + sensorID + " " + _D("Summer") + " " + _D("Standby"),
        step: 0.5,
        min: 5,
        max: 30,
        "modbusrtutcp/read-unit-id": slaveID,
        "modbusrtutcp/read-function-id": 3, // (3) Read Holding Registers
        "modbusrtutcp/read-register-start": sensorOffset + 140,
        "modbusrtutcp/read-register-count": 7,
        "modbusrtutcp/read-bit-start": 64,
        "modbusrtutcp/read-bit-count": 16,
        "modbusrtutcp/read-transform-type": 4, // word
        "modbusrtutcp/read-transform-min": 50,
        "modbusrtutcp/read-transform-max": 300,
        "modbusrtutcp/read-transform-multiplier": 0.1,
        "modbusrtutcp/write-unit-id": slaveID,
        "modbusrtutcp/write-function-id": 6, // (6) Write Single Register
        "modbusrtutcp/write-register-start": sensorOffset + 144,
        "modbusrtutcp/write-register-count": 1,
        "modbusrtutcp/write-bit-start": -1,
        "modbusrtutcp/write-bit-count": 0,
        "modbusrtutcp/write-transform-type": 4, // word
        "modbusrtutcp/write-transform-min": 50,
        "modbusrtutcp/write-transform-max": 300,
        "modbusrtutcp/write-transform-multiplier": 0.1,
        "icons": [
            blr.gfxResource.getIconByTypeName(0, "standby"),
            blr.gfxResource.getIconByTypeName(1, "less"),
            blr.gfxResource.getIconByTypeName(2, "circle"),
            blr.gfxResource.getIconByTypeName(3, "plus")
        ]
    }, oGroup);
    oItem = application.addComponent({
        type: "timed-thermostat",
        gateway: gateway,
        name: "Z" + zoneID + " S" + sensorID + " " + _D("Summer") + " " + _D("Standby") + " " + _D("Timed"),
        step: 0.5,
        min: 5,
        max: 30,
        "modbusrtutcp/read-unit-id": slaveID,
        "modbusrtutcp/read-function-id": 3, // (3) Read Holding Registers
        "modbusrtutcp/read-register-start": sensorOffset + 140,
        "modbusrtutcp/read-register-count": 7,
        "modbusrtutcp/read-bit-start": 64,
        "modbusrtutcp/read-bit-count": 16,
        "modbusrtutcp/read-transform-type": 4, // word
        "modbusrtutcp/read-transform-min": 50,
        "modbusrtutcp/read-transform-max": 300,
        "modbusrtutcp/read-transform-multiplier": 0.1,
        "modbusrtutcp/write-unit-id": slaveID,
        "modbusrtutcp/write-function-id": 6, // (6) Write Single Register
        "modbusrtutcp/write-register-start": sensorOffset + 144,
        "modbusrtutcp/write-register-count": 1,
        "modbusrtutcp/write-bit-start": -1,
        "modbusrtutcp/write-bit-count": 0,
        "modbusrtutcp/write-transform-type": 4, // word
        "modbusrtutcp/write-transform-min": 50,
        "modbusrtutcp/write-transform-max": 300,
        "modbusrtutcp/write-transform-multiplier": 0.1
    }, oGroup);

    oItem = application.addComponent({
        type: "thermostat",
        gateway: gateway,
        name: "Z" + zoneID + " S" + sensorID + " " + _D("Summer") + " " + _D("Night"),
        step: 0.5,
        min: 5,
        max: 30,
        "modbusrtutcp/read-unit-id": slaveID,
        "modbusrtutcp/read-function-id": 3, // (3) Read Holding Registers
        "modbusrtutcp/read-register-start": sensorOffset + 140,
        "modbusrtutcp/read-register-count": 7,
        "modbusrtutcp/read-bit-start": 80,
        "modbusrtutcp/read-bit-count": 16,
        "modbusrtutcp/read-transform-type": 4, // word
        "modbusrtutcp/read-transform-min": 50,
        "modbusrtutcp/read-transform-max": 300,
        "modbusrtutcp/read-transform-multiplier": 0.1,
        "modbusrtutcp/write-unit-id": slaveID,
        "modbusrtutcp/write-function-id": 6, // (6) Write Single Register
        "modbusrtutcp/write-register-start": sensorOffset + 145,
        "modbusrtutcp/write-register-count": 1,
        "modbusrtutcp/write-bit-start": -1,
        "modbusrtutcp/write-bit-count": 0,
        "modbusrtutcp/write-transform-type": 4, // word
        "modbusrtutcp/write-transform-min": 50,
        "modbusrtutcp/write-transform-max": 300,
        "modbusrtutcp/write-transform-multiplier": 0.1,
        "icons": [
            blr.gfxResource.getIconByTypeName(0, "night"),
            blr.gfxResource.getIconByTypeName(1, "less"),
            blr.gfxResource.getIconByTypeName(2, "circle"),
            blr.gfxResource.getIconByTypeName(3, "plus")
        ]
    }, oGroup);
    oItem = application.addComponent({
        type: "timed-thermostat",
        gateway: gateway,
        name: "Z" + zoneID + " S" + sensorID + " " + _D("Summer") + " " + _D("Night") + " " + _D("Timed"),
        step: 0.5,
        min: 5,
        max: 30,
        "modbusrtutcp/read-unit-id": slaveID,
        "modbusrtutcp/read-function-id": 3, // (3) Read Holding Registers
        "modbusrtutcp/read-register-start": sensorOffset + 140,
        "modbusrtutcp/read-register-count": 7,
        "modbusrtutcp/read-bit-start": 80,
        "modbusrtutcp/read-bit-count": 16,
        "modbusrtutcp/read-transform-type": 4, // word
        "modbusrtutcp/read-transform-min": 50,
        "modbusrtutcp/read-transform-max": 300,
        "modbusrtutcp/read-transform-multiplier": 0.1,
        "modbusrtutcp/write-unit-id": slaveID,
        "modbusrtutcp/write-function-id": 6, // (6) Write Single Register
        "modbusrtutcp/write-register-start": sensorOffset + 145,
        "modbusrtutcp/write-register-count": 1,
        "modbusrtutcp/write-bit-start": -1,
        "modbusrtutcp/write-bit-count": 0,
        "modbusrtutcp/write-transform-type": 4, // word
        "modbusrtutcp/write-transform-min": 50,
        "modbusrtutcp/write-transform-max": 300,
        "modbusrtutcp/write-transform-multiplier": 0.1
    }, oGroup);
/*
    // Modo Sensore
    oItem = application.addComponent({
        type: "combo",
        gateway: gateway,
        name: "Z" + zoneID + " S" + sensorID + " " + _D("Mode") + " (" + _D("Read Only") + ")",
        "modbusrtutcp/read-unit-id": slaveID,
        "modbusrtutcp/read-function-id": 3, // (3) Read Holding Registers
        "modbusrtutcp/read-register-start": sensorOffset + 140,
        "modbusrtutcp/read-register-count": 8,
        "modbusrtutcp/read-bit-start": 96,
        "modbusrtutcp/read-bit-count": 16,
        "modbusrtutcp/read-transform-type": 2, // byte
        "modbusrtutcp/read-transform-min": 0,
        "modbusrtutcp/read-transform-max": 2,
        "modbusrtutcp/read-transform-multiplier": 1,
        "modbusrtutcp/write-unit-id": slaveID,
        "modbusrtutcp/write-function-id": 6, // (6) Write Single Register
        "modbusrtutcp/write-register-start": sensorOffset + 146,
        "modbusrtutcp/write-register-count": 1,
        "modbusrtutcp/write-bit-start": -1,
        "modbusrtutcp/write-bit-count": 0,
        "modbusrtutcp/write-transform-type": 2, // byte
        "modbusrtutcp/write-transform-min": 0,
        "modbusrtutcp/write-transform-max": 2,
        "modbusrtutcp/write-transform-multiplier": 1,
        "values": [{
            "value": 0,
            "description": _D("Automatic")
        }, {
            "value": 1,
            "description": _D("Forced")
        }, {
            "value": 2,
            "description": _D("Manual")
        }],
        "icons": [
            blr.gfxResource.getIconByTypeName(0, "automatic"),
            blr.gfxResource.getIconByTypeName(1, "forced"),
            blr.gfxResource.getIconByTypeName(2, "manual")
        ]
    }, oGroup);
*/
    return oGroup;
}


function getGateway(name, address, port) {
    var oGateway = undefined;

    if (oGateway == undefined) {
        oGateway = application.addGateway({
            name: name,
            protocol: "modbusrtutcp"
        });
    }
    oGateway.data.setName(name);
    oGateway.data.setParamVal("modbusrtutcp/address", address);
    oGateway.data.setParamVal("modbusrtutcp/port", port);
    oGateway.data.setParamVal("modbusrtutcp/asciitransform",true);
    return oGateway;
}

function getMainGroup(name) {
    var oGroup = application.addComponent({
        type: "group",
        name: name
    });
    return oGroup;
}